// Copyright 2024 schukai GmbH
// SPDX-License-Identifier: proprietary

package xflags

import (
	"sync"
	"testing"
)

type testI7 struct {
}

func TestRaceCondition(t *testing.T) {
	var wg sync.WaitGroup
	settings := &Settings[testI7]{}

	for i := 0; i < 100; i++ {
		wg.Add(4) // 4 Methoden werden in jeder Iteration aufgerufen

		go func() {
			settings.Execute()
			wg.Done()
		}()
		go func() {
			_ = settings.HelpRequested()
			wg.Done()
		}()
		go func() {
			_ = settings.MissingCommand()
			wg.Done()
		}()
		go func() {
			_ = settings.WasExecuted()
			wg.Done()
		}()
	}

	wg.Wait()
}
