// Copyright 2022 schukai GmbH
// SPDX-License-Identifier: AGPL-3.0

package xflags

import (
	"github.com/stretchr/testify/assert"
	"testing"
)

type ParseMultiTestDefinition struct {
	Values StringFlags `short:"x" long:"yyy" description:"Host to bind to" default:"localhost"`
}

func TestMultiParseIt(t *testing.T) {
	setting := New("test", ParseMultiTestDefinition{})
	setting.Parse([]string{"-x", "a1", "-x", "a2", "--yyy", "a3"})
	setting.Execute()

	if setting.HasErrors() {
		for _, err := range setting.Errors() {
			t.Log(err)
		}
	}

	assert.False(t, setting.HasErrors())
	assert.Equal(t, StringFlags{"a1", "a2", "a3"}, setting.definitions.Values)
}
